/**
  * @file <src/modules/AutoMoDeBehaviourAttractionColor.h>
  *
  * @author Antoine Ligot - <aligot@ulb.ac.be>
  *
  * @package ARGoS3-AutoMoDe
  *
  * @license MIT License
  */

#ifndef AUTOMODE_BEHAVIOUR_CIRCLING_H
#define AUTOMODE_BEHAVIOUR_CIRCLING_H

#include "AutoMoDeBehaviour.h"

namespace argos {
    class AutoMoDeBehaviourCircling: public AutoMoDeBehaviour {
		public:
            AutoMoDeBehaviourCircling();
            AutoMoDeBehaviourCircling(AutoMoDeBehaviourCircling* pc_behaviour);
            virtual ~AutoMoDeBehaviourCircling();

			virtual void ControlStep();
			virtual void Reset();
			virtual void ResumeStep();
			virtual void Init();

            virtual AutoMoDeBehaviourCircling* Clone();

        private:
            Real m_fDistanceWeightParameter;
            CColor m_cColorEmiterParameter;
            Real m_cAngleParameter;
            Real m_unAttractionParameter;
	};
}

#endif
