/**
  * @file <src/modules/AutoMoDeBehaviourAttractionColor.h>
  *
  * @author Antoine Ligot - <aligot@ulb.ac.be>
  *
  * @package ARGoS3-AutoMoDe
  *
  * @license MIT License
  */

#ifndef AUTOMODE_BEHAVIOUR_DRIVEN_H
#define AUTOMODE_BEHAVIOUR_DRIVEN_H

#include "AutoMoDeBehaviour.h"

namespace argos {
    class AutoMoDeBehaviourDriven: public AutoMoDeBehaviour {
		public:
            AutoMoDeBehaviourDriven();
            AutoMoDeBehaviourDriven(AutoMoDeBehaviourDriven* pc_behaviour);
            virtual ~AutoMoDeBehaviourDriven();

			virtual void ControlStep();
			virtual void Reset();
			virtual void ResumeStep();
			virtual void Init();

            virtual AutoMoDeBehaviourDriven* Clone();

        private:
            Real m_fDistanceWeightParameter;
            CColor m_cColorEmiterParameter;
            CColor m_cColorReceiverParameter;
            Real m_unAttractionParameter;
            Real m_fDirectionParameter;
	};
}

#endif
